InvertibleLUCFunction Class Reference

The LUC inverse function. More...

`#include <luc.h>`

Inheritance diagram for InvertibleLUCFunction:

## Public Member Functions

void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits, const Integer &eStart=17)
| Create a LUC private key.
void | Initialize (const Integer &n, const Integer &e, const Integer &p, const Integer &q, const Integer &u)
| Initialize a LUC private key with {n,e,p,q,dp,dq,u}.
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
Integer | CalculateInverse (RandomNumberGenerator &rng, const Integer &x) const
| Calculates the inverse of an element.
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
const Integer & | GetMultiplicativeInverseOfPrime2ModPrime1 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
void | SetMultiplicativeInverseOfPrime2ModPrime1 (const Integer &u)
Public Member Functions inherited from LUCFunction
void | Initialize (const Integer &n, const Integer &e)
| Initialize a LUC public key with {n,e}.
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor.
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied.
Integer | ImageBound () const
| Returns the maximum size of a representation after the trapdoor function is applied.
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function.
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized.
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key.
virtual Integer | MaxImage () const
| Returns the maximum size of a representation after the trapdoor function is applied bound to a public key.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
virtual void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation.
virtual void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation.
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation.
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T>
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T>
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T>
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.
Public Member Functions inherited from TrapdoorFunctionInverse
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
| Applies the inverse of the trapdoor function.
bool | IsRandomized () const
| Determines if the decryption algorithm is randomized.
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters.

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

The LUC inverse function.

This class is here for historical and pedagogical interest. It has no practical advantages over other trapdoor functions and probably shouldn't be used in production software. The discrete log based LUC schemes defined later in this .h file may be of more practical interest.

Since
  Crypto++ 2.1

Definition at line 78 of file luc.h.

## Constructor & Destructor Documentation

## ~InvertibleLUCFunction()

virtual InvertibleLUCFunction::~InvertibleLUCFunction | ( |  | ) |

inline virtual

Definition at line 83 of file luc.h.

## Member Function Documentation

## Initialize() [1/2]

void InvertibleLUCFunction::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | modulusBits,
|  | const Integer & | eStart = 17 )

Create a LUC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  modulusBits | the size of the modulus, in bits
  eStart | the desired starting public exponent

Initialize() creates a new keypair using a starting public exponent of 17.

This function overload of Initialize() creates a new keypair because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 137 of file luc.cpp.

## Initialize() [2/2]

void InvertibleLUCFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e,
|  | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | u )

inline

Initialize a LUC private key with {n,e,p,q,dp,dq,u}.

Parameters

  n | modulus
  e | public exponent
  p | first prime factor
  q | second prime factor
  u | q-1 mod p

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 102 of file luc.h.

## BERDecode()

void InvertibleLUCFunction::BERDecode | ( | BufferedTransformation & | bt | ) |

Definition at line 142 of file luc.cpp.

## DEREncode()

void InvertibleLUCFunction::DEREncode | ( | BufferedTransformation & | bt | ) | const

Definition at line 158 of file luc.cpp.

## CalculateInverse()

Integer InvertibleLUCFunction::CalculateInverse | ( | RandomNumberGenerator & | rng,
|  | const Integer & | x ) const

virtual

Calculates the inverse of an element.

Parameters

  rng | a RandomNumberGenerator derived class
  x | the element

Returns
  the inverse of the element in the group

Implements TrapdoorFunctionInverse.

Definition at line 172 of file luc.cpp.

## Validate()

bool InvertibleLUCFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level ) const

virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

Definition at line 180 of file luc.cpp.

## GetVoidValue()

bool InvertibleLUCFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue ) const

virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Definition at line 213 of file luc.cpp.

## AssignFrom()

void InvertibleLUCFunction::AssignFrom | ( | const NameValuePairs & | source | ) |

virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Definition at line 222 of file luc.cpp.

## GenerateRandom()

void InvertibleLUCFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg )

virtual

parameters: (ModulusSize, PublicExponent (default 17))

Reimplemented from GeneratableCryptoMaterial.

Definition at line 114 of file luc.cpp.

## GetPrime1()

const Integer & InvertibleLUCFunction::GetPrime1 | ( |  | ) | const

inline

Definition at line 117 of file luc.h.

## GetPrime2()

const Integer & InvertibleLUCFunction::GetPrime2 | ( |  | ) | const

inline

Definition at line 118 of file luc.h.

## GetMultiplicativeInverseOfPrime2ModPrime1()

const Integer & InvertibleLUCFunction::GetMultiplicativeInverseOfPrime2ModPrime1 | ( |  | ) | const

inline

Definition at line 119 of file luc.h.

## SetPrime1()

void InvertibleLUCFunction::SetPrime1 | ( | const Integer & | p | ) |

inline

Definition at line 121 of file luc.h.

## SetPrime2()

void InvertibleLUCFunction::SetPrime2 | ( | const Integer & | q | ) |

inline

Definition at line 122 of file luc.h.

## SetMultiplicativeInverseOfPrime2ModPrime1()

void InvertibleLUCFunction::SetMultiplicativeInverseOfPrime2ModPrime1 | ( | const Integer & | u | ) |

inline

Definition at line 123 of file luc.h.

The documentation for this class was generated from the following files:

- luc.h
- luc.cpp